CF 1900B Laura and Operations 学习笔记

原题链接

传送门

题意

输入三个数字a,b,c表示1,2,3的数目,也就是说有a个1,b个2,c个3,每一次可以删除两个不同的数字,增加一个剩下的数字,比如说删除1和3,增加2,问经过多次操作,能不能使得所有数字只有1,或者只有2,只有3

代码

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;

int main()
{
	int t;
	scanf("%d",&t);
	
	while(t--)
	{
		int a,b,c;
		scanf("%d%d%d",&a,&b,&c);
		
		if(a==b&&b==c)	printf ("1 1 1\n");
		else
		{
			if((b+c)%2==0)
			{
				printf("1 ");
			}
			else
			{
				printf("0 ");
			}
			
			if((a+c)%2==0)
			{
				printf("1 ");
			}
			else
			{
				printf("0 ");
			}
			
			if((a+b)%2==0)
			{
				printf("1\n");
			}
			else
			{
				printf("0\n");
			}
		}
	}
	
	return 0;
}

总结

1.因为英文的原因,读了挺多遍才理解题目的意思

2.赛时我是根据样例分析,猜出来的,赛时可以自己多模拟几个样例检测自己猜的结论是否具有普适性

3.根据奇偶性分析,删去的两个数字奇偶性有两种情况,第一种情况,都是奇数,第二种情况,都是偶数,(写到这里想起来,一道题写完之后最好马上写一下总结,不然,之后补总结,题目积累多了,就不想补了,有几个题目就不想写了)

4.有一个性质,删去1和2,a和b的和的奇偶性不会发生变化,a和b的和每一次都是减小2的倍数,如果和是奇数,表示原来的两个数字分别是奇数和偶数,也就是说奇偶校验不一致,假设最后要得到只剩下数字1,就要求2和3最后的数量都等于0,假设2和3的数量的奇偶校验不一致,无法使得最后满足要求,所以b和c的奇偶校验必须一致才能最后只剩下1

5.背后的数学原理是:经过一次操作之后什么不会发生变化,考虑只有1 剩下的情况,经过一次操作,a会增加1,b和c都会减小1,b+c的奇偶性不会发生变化,因为每一次都是减小2,b和c最终都要减小到0,表示两个数字的奇偶性相同,每一次操作都是减小1,b+c的奇偶性必须是偶数才行

6.总的来说就是,b+c的奇偶性不会发生变化,b+c最后要变成0,所以b+c必须要是偶数

7.考虑到上述情况即可解决该题,参考:官方题解,其他选手代码,以及该题解传送门

相关推荐
Nuanyt5 分钟前
LeetCode Hot 100 · 双指针 3 题 Java
java·笔记·算法·leetcode·双指针
深圳老胡18 分钟前
FDC2212 + STM32G030 液面探测:IIC 读数跳动导致下探深度不一致的排查与解决
笔记·stm32·单片机·代码规范·1024程序员节
程序边界31 分钟前
一台数据集成软件的拆解笔记(上):把 KFS 装起来、跑起来,再挑一堆毛病
笔记·原型模式
小嘉丶学长34 分钟前
Day06 · 数据类型与类型检测
开发语言·python·学习·1024程序员节
叼烟扛炮35 分钟前
Linux 学习笔记(二十九):进程信号(上)—— 信号捕捉与异步魔法
linux·运维·笔记·学习·1024程序员节
曾庆睿1 小时前
计算机图形学入门笔记_GAMES101_Lecture01-02
笔记·计算机图形学
coolwest1 小时前
某游戏辅助完整破解复盘报告(仅用于本人学习记录)
笔记
Go Work1 小时前
npm 卡在 Step 7 七分钟,翻上去四行才看到 E404
经验分享·笔记
代码山河1 小时前
调试技巧:IDEA Debug模式入门与使用
java·学习·架构·教程·面向对象·项目
外收内放1 小时前
FastAPI猜字谜实战(5):会话管理
开发语言·python·学习·fastapi